diff -r 1e55e1aa8b7f sys/netinet/tcp_usrreq.c
--- a/sys/netinet/tcp_usrreq.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_usrreq.c	Fri Jul 11 13:32:06 2014 +1000
@@ -46,10 +46,17 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/limits.h>
+#include <sys/endian.h>
+#include <sys/lock.h>
 #include <sys/malloc.h>
+#include <sys/mutex.h>
+#include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/sysctl.h>
 #include <sys/mbuf.h>
+#include <sys/queue.h>
+#include <sys/taskqueue.h>
+
 #ifdef INET6
 #include <sys/domain.h>
 #endif /* INET6 */
@@ -80,10 +87,13 @@
 #include <netinet6/ip6_var.h>
 #include <netinet6/scope6_var.h>
 #endif
+
 #include <netinet/tcp_fsm.h>
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_var.h>
 #include <netinet/tcpip.h>
 #ifdef TCPDEBUG
 #include <netinet/tcp_debug.h>
@@ -171,6 +181,7 @@
 
 	tp = intotcpcb(inp);
 
+
 	if (inp->inp_flags & INP_TIMEWAIT) {
 		/*
 		 * There are two cases to handle: one in which the time wait
@@ -384,6 +395,7 @@
 }
 #endif /* INET */
 
+
 #ifdef INET6
 static int
 tcp6_usr_listen(struct socket *so, int backlog, struct thread *td)
@@ -436,18 +448,24 @@
  * Enter SYN_SENT state, and mark socket as connecting.
  * Start keep-alive timer, and seed output sequence space.
  * Send initial segment on connection.
+ *
+ *
  */
 static int
 tcp_usr_connect(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
 	int error = 0;
 	struct inpcb *inp;
+	struct mpcb *mp;
 	struct tcpcb *tp = NULL;
 	struct sockaddr_in *sinp;
 
+	printf("%s: entered\n", __func__);
+
 	sinp = (struct sockaddr_in *)nam;
 	if (nam->sa_len != sizeof (*sinp))
 		return (EINVAL);
+
 	/*
 	 * Must disallow TCP ``connections'' to multicast addresses.
 	 */
@@ -465,10 +483,24 @@
 		error = EINVAL;
 		goto out;
 	}
-	tp = intotcpcb(inp);
+
+	if ((so->so_state & SS_ISCONNECTED) == 0)  {
+		tp = intotcpcb(inp);
+		if ((error = tcp_connect(tp, nam, td)) != 0)
+			goto out;
+	} else {
+		INP_WUNLOCK(inp);
+		/* Aquire mp and (tp, inp) for most recently added subflow */
+		mp = sototcpcb(so)->t_mpcb;
+		tp = (SLIST_FIRST(&mp->tp_list));
+		inp = tp->t_inpcb;
+
+		KASSERT(tp != NULL, ("tcp_usr_connect: subflow tp == NULL"));
+		if ((error = tcp_subflow_connect(tp, nam, td)) != 0)
+			goto out;
+	}
+	
 	TCPDEBUG1();
-	if ((error = tcp_connect(tp, nam, td)) != 0)
-		goto out;
 #ifdef TCP_OFFLOAD
 	if (registered_toedevs > 0 &&
 	    (so->so_options & SO_NO_OFFLOAD) == 0 &&
@@ -477,6 +509,7 @@
 #endif
 	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
 	error = tcp_output(tp);
+
 out:
 	TCPDEBUG2(PRU_CONNECT);
 	INP_WUNLOCK(inp);
@@ -484,6 +517,7 @@
 }
 #endif /* INET */
 
+
 #ifdef INET6
 static int
 tcp6_usr_connect(struct socket *so, struct sockaddr *nam, struct thread *td)
@@ -583,29 +617,90 @@
 static int
 tcp_usr_disconnect(struct socket *so)
 {
-	struct inpcb *inp;
-	struct tcpcb *tp = NULL;
+	int close_socket = 1;
 	int error = 0;
+	struct inpcb *sf_inp;
+	struct mpcb *mp;
+	struct tcpcb *sf_tp;
+
+	sf_tp = sototcpcb(so);
+	mp = sf_tp->t_mpcb;
 
 	TCPDEBUG0;
 	INP_INFO_WLOCK(&V_tcbinfo);
-	inp = sotoinpcb(so);
-	KASSERT(inp != NULL, ("tcp_usr_disconnect: inp == NULL"));
-	INP_WLOCK(inp);
-	if (inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {
-		error = ECONNRESET;
-		goto out;
+	SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+		sf_inp = sf_tp->t_inpcb;
+		KASSERT(sf_inp != NULL, ("tcp_usr_disconnect: tp %p inp == NULL", sf_tp));
+
+		printf("%s: start close on tp %p\n", __func__, sf_tp);
+
+		INP_WLOCK(sf_inp);
+		if (sf_inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {
+			error = ECONNRESET;
+			TCPDEBUG2(PRU_DISCONNECT);
+			INP_WUNLOCK(sf_inp);
+			goto out;
+		}
+		sf_tp = intotcpcb(sf_inp);
+
+		/* XXXNJW: need to overhaul how multiple subflows are being closed, as
+		 * it gets a bit messy if subflows shutdown with different paths thru
+		 * shutdown states.
+		 * Only need to call tcp_disconnect once.
+		 * close_socket == 1: Call tcp_disconnect, which flushed buffers,
+		 * calls sowakup, calls tcp_usrclosed, tcp_output.
+		 * close_socket == 0: Just set the state and call tcp_output to
+		 * issue the FIN */
+		if (close_socket) {
+			printf("%s: first loop through tp list, tp %p\n", __func__, sf_tp);
+			TCPDEBUG1();
+			tcp_disconnect(sf_tp);
+			TCPDEBUG2(PRU_DISCONNECT);
+			close_socket = 0;
+		} else {
+			printf("%s: second loop through tp list, tp %p\n", __func__, sf_tp);
+			tcp_usrclosed(sf_tp);
+			if (!(sf_inp->inp_flags & INP_DROPPED))
+				tcp_output(sf_tp);
+		}
+		if (sf_tp->t_inpcb)
+			INP_WUNLOCK(sf_inp);
 	}
-	tp = intotcpcb(inp);
-	TCPDEBUG1();
-	tcp_disconnect(tp);
 out:
-	TCPDEBUG2(PRU_DISCONNECT);
-	INP_WUNLOCK(inp);
 	INP_INFO_WUNLOCK(&V_tcbinfo);
 	return (error);
 }
 
+//static int
+//tcp_usr_disconnect(struct socket *so)
+//{
+//	struct inpcb *inp;
+//	struct tcpcb *tp = NULL;
+//	int error = 0;
+//
+//	TCPDEBUG0;
+//	INP_INFO_WLOCK(&V_tcbinfo);
+//	inp = sotoinpcb(so);
+//	KASSERT(inp != NULL, ("tcp_usr_disconnect: inp == NULL"));
+//	INP_WLOCK(inp);
+//	if (inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {
+//		error = ECONNRESET;
+//		goto out;
+//	}
+//	tp = intotcpcb(inp);
+//
+//	printf("%s: calling tcp_disco. tp %p\n", __func__, tp);
+//
+//	TCPDEBUG1();
+//	tcp_disconnect(tp);
+//out:
+//	TCPDEBUG2(PRU_DISCONNECT);
+//	INP_WUNLOCK(inp);
+//	INP_INFO_WUNLOCK(&V_tcbinfo);
+//	return (error);
+//}
+
+
 #ifdef INET
 /*
  * Accept a connection.  Essentially all the work is done at higher levels;
@@ -765,8 +860,11 @@
 		tcp_offload_rcvd(tp);
 	else
 #endif
+
+	/* the app has read in data and an ACK/DACK will now
+	 * be scheduled for the next output.
+	 */
 	tcp_output(tp);
-
 out:
 	TCPDEBUG2(PRU_RCVD);
 	INP_WUNLOCK(inp);
@@ -813,6 +911,57 @@
 	isipv6 = nam && nam->sa_family == AF_INET6;
 #endif /* INET6 */
 	tp = intotcpcb(inp);
+
+	/* temporary "round-robin" -like behaviour. Distributes pru_usr_send calls
+	 * to tcp_output between the available subflows. Works for two subflows. */
+	if (tp->mp_active) {
+		struct tcpcb *sf_tp;
+		struct mpcb *mp = tp->t_mpcb;
+
+		/* Not the last segment, and more than one subflow */
+		if (!(flags & PRUS_EOF) && (mp->subflow_cnt > 1)) {
+			INP_INFO_WLOCK(&V_tcbinfo);
+
+			/* Subflow must be waiting to send data, have room for at least
+			 * on segment in the send window and not be in retransmit. If the
+			 * flow is in rexmit then the tcp timers will take care of calling
+			 * tcp_output and sending data. */
+			SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+				if ((sf_tp->sf_flags & SFF_SEND_WAIT)
+					&& (sf_tp->snd_cwnd >= sf_tp->t_maxseg)
+				    && (sf_tp->t_rxtshift == 0)) {
+					/* don't send if in time_wait, not established  */
+					if ((sf_tp->t_inpcb->inp_flags & (INP_TIMEWAIT | INP_DROPPED))
+						|| (sf_tp->t_state != TCPS_ESTABLISHED)) {
+						tp->sf_flags &= ~SFF_SEND_WAIT;
+						continue;
+					}
+					/* unlock the current inp, and re-assign to sf_inp */
+					INP_WUNLOCK(inp);
+					inp = sf_tp->t_inpcb;
+					INP_WLOCK(inp);
+					if (inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {			// should be checked above anyway
+						printf("%s: found a subflow in timewait - break\n",
+						    __func__);
+						kdb_break();
+					}
+					tp = sf_tp;
+					/* assigned tp to send on, break loop */
+					break;
+				} else {
+					/* Can use this subflow next time through */
+					sf_tp->sf_flags |= SFF_SEND_WAIT;
+				}
+			}
+			INP_INFO_WUNLOCK(&V_tcbinfo);
+
+			/* Dont want to send from this sf next time */
+			tp->sf_flags &= ~SFF_SEND_WAIT;
+		}
+
+	}
+	/* End "Round-Robin" allocation */
+
 	TCPDEBUG1();
 	if (control) {
 		/* TCP doesn't do control messages (rights, creds, etc) */
@@ -976,25 +1125,30 @@
 	INP_INFO_WLOCK(&V_tcbinfo);
 	INP_WLOCK(inp);
 	KASSERT(inp->inp_socket != NULL,
-	    ("tcp_usr_close: inp_socket == NULL"));
+		("tcp_usr_close: inp_socket == NULL"));
 
 	/*
 	 * If we still have full TCP state, and we're not dropped, initiate
 	 * a disconnect.
 	 */
 	if (!(inp->inp_flags & INP_TIMEWAIT) &&
-	    !(inp->inp_flags & INP_DROPPED)) {
+		!(inp->inp_flags & INP_DROPPED)) {
 		tp = intotcpcb(inp);
+
+		printf("%s: calling tcp_disco. tp %p\n", __func__, tp);
+
 		TCPDEBUG1();
 		tcp_disconnect(tp);
 		TCPDEBUG2(PRU_CLOSE);
 	}
+
 	if (!(inp->inp_flags & INP_DROPPED)) {
 		SOCK_LOCK(so);
 		so->so_state |= SS_PROTOREF;
 		SOCK_UNLOCK(so);
 		inp->inp_flags |= INP_SOCKREF;
 	}
+
 	INP_WUNLOCK(inp);
 	INP_INFO_WUNLOCK(&V_tcbinfo);
 }
@@ -1105,6 +1259,8 @@
 	u_short lport;
 	int error;
 
+	struct mpcb *mp;
+
 	INP_WLOCK_ASSERT(inp);
 	INP_HASH_WLOCK(&V_tcbinfo);
 
@@ -1144,7 +1300,117 @@
 
 	soisconnecting(so);
 	TCPSTAT_INC(tcps_connattempt);
+	tp->t_state = TCPS_SYN_SENT;
+	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
+	tp->iss = tcp_new_isn(tp);
+	tcp_sendseqinit(tp);
+
+	/*
+	 * Create new multipath control block. for the connection
+	 * inp and socket are set in mp_newmpcb
+	 */
+	mp = mp_newmpcb(inp);
+	mp->master_tcpcb = tp;
+
+	/* add subflow tp to tp_list */
+	SLIST_INSERT_HEAD(&mp->tp_list, mp->master_tcpcb, next_subflow);
+
+	mp->subflow_cnt = 1;
+	tp->t_mpcb = mp;
+
+	/* should have a sysctl to check if we want to enable */
+	tp->mp_enabled = 1;
+	tp->infinite_map = 1;
+
+	/* XXXNJW: temporary - disable multipath on local connections */
+	if (inp->inp_faddr.s_addr == inp->inp_laddr.s_addr)
+		tp->mp_enabled = 0;
+
+	/* XXXNJW: cheap check to disable multipath for localhost connections */
+	struct sockaddr_in localhost_addr;
+	inet_pton(AF_INET, "127.0.0.1", &localhost_addr.sin_addr);
+	if (inp->inp_laddr.s_addr == localhost_addr.sin_addr.s_addr)
+		tp->mp_enabled = 0;
+
+	STAILQ_INSERT_TAIL(&mp->sf_reass_queues_list, tp->t_segq, tqe_next_head);
+
+	if (tp->t_mpcb->mp_state == MPS_CLOSED) {
+		mp_process_local_key(tp->t_mpcb, mp_generate_local_key());
+
+		/* Always start in direct mapping mode */
+		tp->t_mpcb->ds_map_max = tp->t_mpcb->ds_map_min = tp->t_mpcb->ds_snd_una = tp->iss + 1;
+		tp->t_mpcb->mp_state = MPS_SYN_SENT;
+
+	}
+
+	return 0;
+
+out:
+	INP_HASH_WUNLOCK(&V_tcbinfo);
+	return (error);
+}
+#endif /* INET */
+
+
+/* XXXNJW: Refactoring needed to tidy and reduce code duplication.
+ */
+int
+tcp_subflow_connect(struct tcpcb *tp, struct sockaddr *nam, struct thread *td)
+{
+	struct inpcb *inp = tp->t_inpcb, *oinp;
+	struct in_addr laddr;
+	u_short lport;
+	int error = 0;
+
+	INP_WLOCK_ASSERT(inp);
+	INP_HASH_WLOCK(&V_tcbinfo);
+
+	/*
+	 * If lport == 0., set an ephemeral port number. otherise we just
+	 * add directly into hash list.
+	 */
+	if (inp->inp_lport == 0) {
+		error = in_pcbbind(inp, (struct sockaddr *)0, td->td_ucred);
+	} else {
+		error = in_pcbinshash(inp);
+		mp_debug(MPSESSION, 4, 0, "%s: in_pcbhash error %d\n", __func__, error);
+	}
+	if (error)
+		goto out;
+
+	/*
+	 * Cannot simply call in_pcbconnect, because there might be an
+	 * earlier incarnation of this same connection still in
+	 * TIME_WAIT state, creating an ADDRINUSE error.
+	 */
+	laddr = inp->inp_laddr;
+	lport = inp->inp_lport;
+	error = in_pcbconnect_setup(inp, nam, &laddr.s_addr, &lport,
+	    &inp->inp_faddr.s_addr, &inp->inp_fport, &oinp, td->td_ucred);
+
+	if (error && oinp == NULL) {
+		goto out;
+	}
+	if (oinp) {
+		error = EADDRINUSE;
+		goto out;
+	}
+	inp->inp_laddr = laddr;
+	in_pcbrehash(inp);
+	INP_HASH_WUNLOCK(&V_tcbinfo);
+
+	/*
+	 * Compute window scaling to request:
+	 * Scale to fit into sweet spot.  See tcp_syncache.c.
+	 * XXX: This should move to tcp_output().
+	 */
+	while (tp->request_r_scale < TCP_MAX_WINSHIFT &&
+	    (TCP_MAXWIN << tp->request_r_scale) < sb_max)
+		tp->request_r_scale++;
+
+	TCPSTAT_INC(tcps_connattempt);
 	tcp_state_change(tp, TCPS_SYN_SENT);
+	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
 	tp->iss = tcp_new_isn(tp);
 	tcp_sendseqinit(tp);
 
@@ -1154,7 +1420,6 @@
 	INP_HASH_WUNLOCK(&V_tcbinfo);
 	return (error);
 }
-#endif /* INET */
 
 #ifdef INET6
 static int
@@ -1616,8 +1881,9 @@
 static int
 tcp_attach(struct socket *so)
 {
+	struct inpcb *inp;
 	struct tcpcb *tp;
-	struct inpcb *inp;
+
 	int error;
 
 	if (so->so_snd.sb_hiwat == 0 || so->so_rcv.sb_hiwat == 0) {
@@ -1627,6 +1893,7 @@
 	}
 	so->so_rcv.sb_flags |= SB_AUTOSIZE;
 	so->so_snd.sb_flags |= SB_AUTOSIZE;
+	so->so_snd.sb_flags |= SB_DEFERACCT;
 	INP_INFO_WLOCK(&V_tcbinfo);
 	error = in_pcballoc(so, &V_tcbinfo);
 	if (error) {
@@ -1642,6 +1909,7 @@
 	else
 #endif
 	inp->inp_vflag |= INP_IPV4;
+
 	tp = tcp_newtcpcb(inp);
 	if (tp == NULL) {
 		in_pcbdetach(inp);
@@ -1656,6 +1924,41 @@
 }
 
 /*
+ * Attach TCP protocol to subflow inp, allocating
+ * buffer space, and entering LISTEN state.
+ */
+int
+tcp_subflow_attach(struct socket *so, struct inpcb *inp, struct mpcb *mp)
+{
+	struct tcpcb *tp;
+
+	INP_WLOCK_ASSERT(inp);
+#ifdef INET6
+	if (inp->inp_vflag & INP_IPV6PROTO) {
+		inp->inp_vflag |= INP_IPV6;
+		inp->in6p_hops = -1;	/* use kernel default */
+	}
+	else
+#endif
+	inp->inp_vflag |= INP_IPV4;
+
+	tp = tcp_newtcpcb(inp);
+
+	if (tp == NULL) {
+		return (ENOBUFS);
+	}
+	/* Add sf to list of subflow blocks */
+	SLIST_INSERT_HEAD(&mp->tp_list, tp, next_subflow);
+	tp->t_mpcb = mp;
+
+	/* Subflows only join mp-enabled sessions */
+	tp->mp_enabled = 1;
+
+	tp->t_state = TCPS_CLOSED;
+	return 0;
+}
+
+/*
  * Initiate (or continue) disconnect.
  * If embryonic state, just send reset (once).
  * If in ``let data drain'' option and linger null, just drop.
@@ -1677,19 +1980,24 @@
 	 * socket is still open.
 	 */
 	if (tp->t_state < TCPS_ESTABLISHED) {
+		printf("%s: closing tp that didn't reach established %p\n", __func__,
+		    tp);
 		tp = tcp_close(tp);
-		KASSERT(tp != NULL,
-		    ("tcp_disconnect: tcp_close() returned NULL"));
+//		KASSERT(tp != NULL,
+//		    ("tcp_disconnect: tcp_close() returned NULL"));
 	} else if ((so->so_options & SO_LINGER) && so->so_linger == 0) {
 		tp = tcp_drop(tp, 0);
 		KASSERT(tp != NULL,
 		    ("tcp_disconnect: tcp_drop() returned NULL"));
 	} else {
+		printf("%s: about to call so is disco with tp %p\n", __func__, tp);		//needs a check for how many subflows?
 		soisdisconnecting(so);
 		sbflush(&so->so_rcv);
 		tcp_usrclosed(tp);
-		if (!(inp->inp_flags & INP_DROPPED))
+		if (!(inp->inp_flags & INP_DROPPED)) {
+			printf("%s: call tcp_output %p\n", __func__, tp);
 			tcp_output(tp);
+		}
 	}
 }
 
@@ -1719,12 +2027,15 @@
 	case TCPS_CLOSED:
 		tcp_state_change(tp, TCPS_CLOSED);
 		tp = tcp_close(tp);
-		/*
-		 * tcp_close() should never return NULL here as the socket is
-		 * still open.
-		 */
-		KASSERT(tp != NULL,
-		    ("tcp_usrclosed: tcp_close() returned NULL"));
+//		/*
+//		 * tcp_close() should never return NULL here as the socket is
+//		 * still open.
+//		 */
+//		KASSERT(tp != NULL,
+//		    ("tcp_usrclosed: tcp_close() returned NULL"));
+		/* A null return is okay as this is a valid return when we have
+		 * multiple subflows (i.e. a subflow can be detached and we still
+		 * could have other subflows that are using the open socket. */
 		break;
 
 	case TCPS_SYN_SENT:
@@ -1733,22 +2044,29 @@
 		break;
 
 	case TCPS_ESTABLISHED:
-		tcp_state_change(tp, TCPS_FIN_WAIT_1);
+		tcp_state_change(tp, TCPS_FIN_WAIT_1); //XXXNJW should be set after all DS-level is acked
 		break;
 
 	case TCPS_CLOSE_WAIT:
 		tcp_state_change(tp, TCPS_LAST_ACK);
 		break;
 	}
-	if (tp->t_state >= TCPS_FIN_WAIT_2) {
-		soisdisconnected(tp->t_inpcb->inp_socket);
-		/* Prevent the connection hanging in FIN_WAIT_2 forever. */
-		if (tp->t_state == TCPS_FIN_WAIT_2) {
-			int timeout;
+	/* if the tp hasn't been detatched */
+	if(tp) {
+		if (tp->t_state >= TCPS_FIN_WAIT_2) {
+			printf("%s: calling soisdisco \n", __func__);
+			if (tp->t_mpcb == NULL ||
+				(tp->t_mpcb != NULL && tp->t_mpcb->subflow_cnt == 1))
+					soisdisconnected(tp->t_inpcb->inp_socket);
 
-			timeout = (tcp_fast_finwait2_recycle) ? 
-			    tcp_finwait2_timeout : TP_MAXIDLE(tp);
-			tcp_timer_activate(tp, TT_2MSL, timeout);
+			/* Prevent the connection hanging in FIN_WAIT_2 forever. */
+			if (tp->t_state == TCPS_FIN_WAIT_2) {
+				int timeout;
+
+				timeout = (tcp_fast_finwait2_recycle) ?
+					tcp_finwait2_timeout : TP_MAXIDLE(tp);
+				tcp_timer_activate(tp, TT_2MSL, timeout);
+			}
 		}
 	}
 }
@@ -1949,7 +2267,7 @@
 
 	db_print_indent(indent);
 	db_printf("t_segq first: %p   t_segqlen: %d   t_dupacks: %d\n",
-	   LIST_FIRST(&tp->t_segq), tp->t_segqlen, tp->t_dupacks);
+	   TAILQ_FIRST(tp->t_segq), tp->t_segqlen, tp->t_dupacks);
 
 	db_print_indent(indent);
 	db_printf("tt_rexmt: %p   tt_persist: %p   tt_keep: %p\n",
diff -r 1e55e1aa8b7f sys/netinet/tcp_var.h
--- a/sys/netinet/tcp_var.h	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_var.h	Fri Jul 11 13:32:06 2014 +1000
@@ -46,14 +46,21 @@
 
 #endif /* _KERNEL */
 
+/* Subflow send buffer mapping queue entry */
+struct sfsendmap_qent {
+	TAILQ_ENTRY(sfsendmap_qent) sfmap_q;
+	int send_chars;
+	void *sendbuf_idx;
+};
+
 /* TCP segment queue entry */
 struct tseg_qent {
-	LIST_ENTRY(tseg_qent) tqe_q;
+	TAILQ_ENTRY(tseg_qent) tqe_q;
+	uint64_t tqe_dsn;		/* The DSN for this entry */
 	int	tqe_len;		/* TCP segment data length */
 	struct	tcphdr *tqe_th;		/* a pointer to tcp header */
 	struct	mbuf	*tqe_m;		/* mbuf contains packet */
 };
-LIST_HEAD(tsegqe_head, tseg_qent);
 
 struct sackblk {
 	tcp_seq start;		/* start seq no. of sack block */
@@ -95,21 +102,53 @@
 #define ND6_HINT(tp)
 #endif
 
+/* Used to map outgoing and incoming segments. Maintained in
+ * t_txmaps and t_rxmaps lists. mbuf_start and mbuf_offset
+ * are not used in the rx context.
+ */
+struct ds_map {
+	TAILQ_ENTRY(ds_map) sf_ds_map_next;
+	TAILQ_ENTRY(ds_map) mp_ds_map_next;
+	TAILQ_ENTRY(ds_map) mp_dup_map_next;
+	TAILQ_ENTRY(ds_map) rxmit_map_next;
+	uint64_t ds_map_start;	/* starting DSN of mapping */
+	uint32_t ds_map_len;	/* length of data sequence mapping */
+	uint32_t ds_map_offset;	/* bytes sent from mapping */
+	tcp_seq	sf_seq_start; /* starting tcp seq num of mapping */
+	struct tcpcb *sf_tp; /* pointer to the sf that this was created for */		// might remove later
+//	uint64_t map_una;		/* bytes sent but unacknowledged in map */
+	uint16_t ds_map_csum;	/* csum of dss psuedo-header and all mapping data */
+	struct mbuf* mbuf_start; /* mbuf in send sockbuf in which this mappings starts */
+	u_int	mbuf_offset;	/* offset into mbuf where data starts */
+	uint32_t flags;
+};
+TAILQ_HEAD(dsmapq_head, ds_map);
+
+/* for unmapped segments received */
+TAILQ_HEAD(sf_unmapped_queue_head, tseg_qent);
+
+
 /*
  * Tcp control block, one per tcp; fields:
  * Organized for 16 byte cacheline efficiency.
  */
 struct tcpcb {
-	struct	tsegqe_head t_segq;	/* segment reassembly queue */
 	void	*t_pspare[2];		/* new reassembly queue */
 	int	t_segqlen;		/* segment reassembly queue length */
 	int	t_dupacks;		/* consecutive dup acks recd */
 
+	struct sf_reass_queue_head *t_segq;	/* points to head of reass queue */
+	struct sf_unmapped_queue_head *t_unmapped_segq; /* unmapped segments buffer */
+
 	struct tcp_timer *t_timers;	/* All the TCP timers in one struct */
 
 	struct	inpcb *t_inpcb;		/* back pointer to internet pcb */
+	struct	mpcb *t_mpcb;		/* back pointer to multipath cb */
+
 	int	t_state;		/* state of this connection */
+	int sf_state;		/* mp state for slave subflows */
 	u_int	t_flags;
+	u_int	sf_flags;	/* flags for this subflow */
 
 	struct	vnet *t_vnet;		/* back pointer to parent vnet */
 
@@ -194,6 +233,7 @@
 	int	t_rttlow;		/* smallest observerved RTT */
 	u_int32_t	rfbuf_ts;	/* recv buffer autoscaling timestamp */
 	int	rfbuf_cnt;		/* recv buffer autoscaling byte count */
+	//struct toe_usrreqs *t_tu;	/* offload operations vector */
 	struct toedev	*tod;		/* toedev handling this connection */
 	int	t_sndrexmitpack;	/* retransmit packets sent */
 	int	t_rcvoopack;		/* out-of-order packets received */
@@ -213,6 +253,25 @@
 	uint32_t t_ispare[8];		/* 5 UTO, 3 TBD */
 	void	*t_pspare2[4];		/* 1 TCP_SIGNATURE, 3 TBD */
 	uint64_t _pad[6];		/* 6 TBD (1-2 CC/RTT?) */
+
+	/* MULTIPATH */
+	uint8_t	mp_enabled:1,	/* try to use mptcp (sysctl is enabled) */
+			mp_active:1,	/* mp session is active on this flow */
+			mpc:1,			/* other end supports mptcp */
+			sent_capable:1, /* sent mp_cable */
+			infinite_map:1;	/* are we in infinite map mode */
+
+	struct dsmapq_head t_txdsmaps;	/* data sequence map outgoing */
+	struct dsmapq_head t_rxdsmaps;	/* data sequence map incoming */
+	u_long	init_cwnd;	/* establish mptcp once this window fills */
+	uint32_t local_rand;	/* random number for join HMAC */
+	uint32_t remote_rand;	/* random number for join HMAC */
+	uint32_t mp_conn_token;	/* mp session this belongs to */
+	SLIST_ENTRY(tcpcb) next_subflow;
+
+	uint8_t 	hmac_local[20];	/* MP_JOIN handshakes use HMACs to ensure */
+	uint8_t 	hmac_remote[20];	/* that a subflow belongs to connection */
+	uint64_t	hmac_trun_remote; /* mp_join sender truncated mac */
 };
 
 /*
@@ -232,6 +291,7 @@
 #define	TF_NEEDFIN	0x000800	/* send FIN (implicit state) */
 #define	TF_NOPUSH	0x001000	/* don't push */
 #define	TF_PREVVALID	0x002000	/* saved values for bad rxmit valid */
+#define	TF_MPTCP		0x004000	/* MPTCP options present */
 #define	TF_MORETOCOME	0x010000	/* More data to be appended to sock */
 #define	TF_LQ_OVERFLOW	0x020000	/* listen queue overflow */
 #define	TF_LASTIDLE	0x040000	/* connection was previously idle */
@@ -247,6 +307,7 @@
 #define	TF_ECN_SND_ECE	0x10000000	/* ECN ECE in queue */
 #define	TF_CONGRECOVERY	0x20000000	/* congestion recovery mode */
 #define	TF_WASCRECOVERY	0x40000000	/* was in congestion recovery */
+#define	TF_NEED_DFIN	0x80000000	/* send mptcp DFIN */
 
 #define	IN_FASTRECOVERY(t_flags)	(t_flags & TF_FASTRECOVERY)
 #define	ENTER_FASTRECOVERY(t_flags)	t_flags |= TF_FASTRECOVERY
@@ -260,7 +321,19 @@
 #define	ENTER_RECOVERY(t_flags) t_flags |= (TF_CONGRECOVERY | TF_FASTRECOVERY)
 #define	EXIT_RECOVERY(t_flags) t_flags &= ~(TF_CONGRECOVERY | TF_FASTRECOVERY)
 
-#define	BYTES_THIS_ACK(tp, th)	(th->th_ack - tp->snd_una)
+#define	OURSYNISACKED(tp, th)												\
+(((tp)->t_state == TCPS_SYN_SENT) && ((th)->th_ack == (tp)->iss + 1) ? 1 : 0)
+
+#define	OURFINISACKED(tp, th)												\
+(((tp)->t_flags & TF_SENTFIN) && ((th)->th_ack == (tp)->snd_max) ? 1 : 0)
+
+#define	FAKE_BYTES_THIS_ACK(tp, th)											\
+	(OURSYNISACKED(tp, th) + OURFINISACKED(tp, th))
+
+#define	BYTES_THIS_ACK(tp, th)												\
+((tp)->snd_una <= (th)->th_ack ?											\
+	((th)->th_ack - (tp)->snd_una - FAKE_BYTES_THIS_ACK(tp, th)) :			\
+	((UINT_MAX - (tp)->snd_una) + 1 + (th)->th_ack - FAKE_BYTES_THIS_ACK(tp, th)))
 
 /*
  * Flags for the t_oobflags field.
@@ -283,6 +356,41 @@
 #define	TCP_SIG_SPI	0x1000
 #endif /* TCP_SIGNATURE */
 
+struct mpopt {
+	uint64_t	mpo_flags;		/* flags for this option */
+	uint8_t		to_mpsubtype;	/* the mptcp option subtype */
+	uint8_t		to_mpoptlen;	/* length of the mptcp option for this segment */
+	uint32_t	add_addr_mask;	/* Bit mask of addresses that have been advertised */
+	uint32_t	join_mask;		/* Addresses we have sent joins for */
+
+	/* KEYS */
+	uint64_t	local_key;	/* locally generated key */
+	uint64_t	remote_key;	/* key generated by remote host */
+
+	/* MP_JOIN */
+	uint32_t	rcv_token;	/* mp_join receive token */
+	uint32_t	snd_rnd;	/* mp_join sender random number */
+	uint64_t	snd_trc_mac;	/* mp_join sender truncated mac */
+
+	/* MP_ADD */
+	struct sockaddr_storage	new_addr;	/* a new address */
+
+	/* DSS */
+	uint64_t	data_ack_num;	/* data ack value */
+	uint64_t	data_seq_num;	/* data sequence number (only 64-bit support for now) */
+	uint64_t	truncated_MAC;	/* truncated (upper 64-bits) MAC for MP_JOIN */
+	uint32_t	sub_seq_num;	/* subflow sequence number */
+	uint16_t	dss_data_len;	/* Data-level length 0 means no DSN */
+	uint16_t	dss_csum;	/* checksum */
+	uint16_t	*dss_data_len_p; /* Pointer to data length in option char */
+	uint8_t		*dss_opts_f_p;	/* pointer to dss flags */
+
+	int		optlen;			/* use this to identify types in segment processing */
+	int		address_count;	/* addresses available for this session */
+	uint8_t	addr_id;		/* address id, used in mp_join */
+	char	*snd_mac;	/* senders MAC, 160-bit sha */
+};
+
 /*
  * Structure to hold TCP options that are only used during segment
  * processing (in tcp_input), but not held in the tcpcb.
@@ -299,7 +407,8 @@
 #define	TOF_TS		0x0010		/* timestamp */
 #define	TOF_SIGNATURE	0x0040		/* TCP-MD5 signature option (RFC2385) */
 #define	TOF_SACK	0x0080		/* Peer sent SACK option */
-#define	TOF_MAXOPT	0x0100
+#define	TOF_MPTCP	0x0100		/* MPTCP options present */
+#define	TOF_MAXOPT	0x0200
 	u_int32_t	to_tsval;	/* new timestamp */
 	u_int32_t	to_tsecr;	/* reflected timestamp */
 	u_char		*to_sacks;	/* pointer to the first SACK blocks */
@@ -308,6 +417,7 @@
 	u_int8_t	to_wscale;	/* window scaling */
 	u_int8_t	to_nsacks;	/* number of SACK blocks */
 	u_int32_t	to_spare;	/* UTO */
+	struct	mpopt	to_mopts;	/* multipath options */
 };
 
 /*
@@ -612,6 +722,8 @@
 VNET_DECLARE(int, path_mtu_discovery);
 VNET_DECLARE(int, tcp_do_rfc3465);
 VNET_DECLARE(int, tcp_abc_l_var);
+VNET_DECLARE(unsigned int, tcp_override_isn);
+#define	V_tcp_override_isn	VNET(tcp_override_isn)
 #define	V_tcb			VNET(tcb)
 #define	V_tcbinfo		VNET(tcbinfo)
 #define	V_tcp_mssdflt		VNET(tcp_mssdflt)
@@ -638,6 +750,15 @@
 VNET_DECLARE(struct hhook_head *, tcp_hhh[HHOOK_TCP_LAST + 1]);
 #define	V_tcp_hhh		VNET(tcp_hhh)
 
+VNET_DECLARE(int, tcp_do_mptcp);	/* MPTCP enabled/disabled */
+#define	V_tcp_do_mptcp		VNET(tcp_do_mptcp)
+
+/*
+ * XXXNJW: use zone allocator. Potentially could have many maps
+ * being alloc'd and dealloc'd if using one map per packet
+ */
+MALLOC_DECLARE(M_DSSMAP);
+
 int	 tcp_addoptions(struct tcpopt *, u_char *);
 int	 tcp_ccalgounload(struct cc_algo *unload_algo);
 struct tcpcb *
@@ -665,6 +786,7 @@
 int	 tcp_reass(struct tcpcb *, struct tcphdr *, int *, struct mbuf *);
 void	 tcp_reass_init(void);
 void	 tcp_reass_flush(struct tcpcb *);
+void	 tcp_reass_release_element(struct tseg_qent *q);
 #ifdef VIMAGE
 void	 tcp_reass_destroy(void);
 #endif
@@ -726,13 +848,29 @@
 void	 tcp_clean_sackreport(struct tcpcb *tp);
 void	 tcp_sack_adjust(struct tcpcb *tp);
 struct sackhole *tcp_sack_output(struct tcpcb *tp, int *sack_bytes_rexmt);
-void	 tcp_sack_partialack(struct tcpcb *, struct tcphdr *);
+void	 tcp_sack_partialack(struct tcpcb *, struct tcphdr *, uint32_t);
 void	 tcp_free_sackholes(struct tcpcb *tp);
 int	 tcp_newreno(struct tcpcb *, struct tcphdr *);
 u_long	 tcp_seq_subtract(u_long, u_long );
 
 void	cc_cong_signal(struct tcpcb *tp, struct tcphdr *th, uint32_t type);
 
+#define IS_MASTER_TP(tp) ((tp->t_mpcb->master_tcpcb) == (tp) ? 1 : 0)
+/*
+#define DIRECT_MAP(tp, var, op) do { \
+	(tp)->var op; \
+	if ((tp)->t_mpcb->direct_map) (tp)->t_mpcb->ds_##var = (tp)->var; \
+} while(0)
+*/
+
+struct mpcb *
+		mp_newmpcb(struct inpcb *);
+void 	mp_discardcb(struct mpcb *mp);
+void	mp_do_reass(struct tcpcb *tp);
+void	tcp_ackmap(struct tcpcb *tp, uint32_t acked, uint64_t data_ack_num);
+void	tcp_unmapped_init(void);
+void	tcp_unmapped_flush(struct tcpcb *tp);
+
 #endif /* _KERNEL */
 
 #endif /* _NETINET_TCP_VAR_H_ */
diff -r 1e55e1aa8b7f sys/sys/sockbuf.h
--- a/sys/sys/sockbuf.h	Sun May 04 01:33:02 2014 +0000
+++ b/sys/sys/sockbuf.h	Fri Jul 11 13:32:06 2014 +1000
@@ -53,6 +53,7 @@
 #define	SB_IN_TOE	0x400		/* socket buffer is in the middle of an operation */
 #define	SB_AUTOSIZE	0x800		/* automatically size socket buffer */
 #define	SB_STOP		0x1000		/* backpressure indicator */
+#define SB_DEFERACCT    0x2000		/* need to account for sb_cc and sb_actual separately */
 
 #define	SBS_CANTSENDMORE	0x0010	/* can't send more data to peer */
 #define	SBS_CANTRCVMORE		0x0020	/* can't receive more data from peer */
@@ -90,7 +91,8 @@
 					 * record in socket buffer */
 	struct	mbuf *sb_sndptr; /* (c/d) pointer into mbuf chain */
 	u_int	sb_sndptroff;	/* (c/d) byte offset of ptr into chain */
-	u_int	sb_cc;		/* (c/d) actual chars in buffer */
+	u_int	sb_cc;		/* (c/d) actively mapped bytes b/w application and protocol  */
+	u_int	sb_actual;	/* (c/d) actual chars in buffer */
 	u_int	sb_hiwat;	/* (c/d) max actual char count */
 	u_int	sb_mbcnt;	/* (c/d) chars of mbufs used */
 	u_int   sb_mcnt;        /* (c/d) number of mbufs in buffer */
@@ -163,12 +165,19 @@
 int	sblock(struct sockbuf *sb, int flags);
 void	sbunlock(struct sockbuf *sb);
 
+/* function to return sb_cc, i.e. chars in sockbuf */
+unsigned int sbgetcc(struct sockbuf *sb);
+
+
 /*
  * How much space is there in a socket buffer (so->so_snd or so->so_rcv)?
  * This is problematical if the fields are unsigned, as the space might
  * still be negative (cc > hiwat or mbcnt > mbmax).  Should detect
  * overflow and return 0.  Should use "lmin" but it doesn't exist now.
  */
+//#define	sbspace(sb) \
+//    ((long) lmin((u_int)((sb)->sb_hiwat - (sb)->sb_cc), \
+//	 (u_int)((sb)->sb_mbmax - (sb)->sb_mbcnt)))
 static __inline
 long
 sbspace(struct sockbuf *sb)
@@ -185,7 +194,10 @@
 
 /* adjust counters in sb reflecting allocation of m */
 #define	sballoc(sb, m) { \
-	(sb)->sb_cc += (m)->m_len; \
+	(sb)->sb_actual += (m)->m_len; \
+	atomic_add_acq_int(&(sb)->sb_cc,(m)->m_len); \
+	if ((sb)->sb_flags & SB_DEFERACCT) KASSERT((sb)->sb_cc <= (sb)->sb_actual, ("sb_cc greater than actual\n")); \
+	else KASSERT((sb)->sb_cc == (sb)->sb_actual, ("SB_DEFER sb_cc greater != actual\n")); \
 	if ((m)->m_type != MT_DATA && (m)->m_type != MT_OOBDATA) \
 		(sb)->sb_ctl += (m)->m_len; \
 	(sb)->sb_mbcnt += MSIZE; \
@@ -198,7 +210,10 @@
 
 /* adjust counters in sb reflecting freeing of m */
 #define	sbfree(sb, m) { \
-	(sb)->sb_cc -= (m)->m_len; \
+	if((sb)->sb_flags & SB_DEFERACCT) KASSERT((int)(sb)->sb_actual - (m)->m_len >= 0 && (sb)->sb_cc <= (sb)->sb_actual - (m)->m_len, ("SB_DEFERACCT sb_cc/sb_actual accounting error: sb_cc %u, sb_actual %u, len %d", (sb)->sb_cc, (sb)->sb_actual, (m)->m_len)); \
+	else KASSERT((int)(sb)->sb_cc - (m)->m_len >= 0 && (int)(sb)->sb_actual - (m)->m_len >= 0 && (sb)->sb_cc - (m)->m_len <= (sb)->sb_actual - (m)->m_len && (sb)->sb_cc == (sb)->sb_actual, ("sb_cc/sb_actual accounting error: sb_cc %u, sb_actual %u, len %d", (sb)->sb_cc, (sb)->sb_actual, (m)->m_len)); \
+	(sb)->sb_actual -= (m)->m_len; \
+	if (!((sb)->sb_flags & SB_DEFERACCT)) (sb)->sb_cc -= (m)->m_len; \
 	if ((m)->m_type != MT_DATA && (m)->m_type != MT_OOBDATA) \
 		(sb)->sb_ctl -= (m)->m_len; \
 	(sb)->sb_mbcnt -= MSIZE; \
diff -r 1e55e1aa8b7f sys/sys/socket.h
--- a/sys/sys/socket.h	Sun May 04 01:33:02 2014 +0000
+++ b/sys/sys/socket.h	Fri Jul 11 13:32:06 2014 +1000
@@ -42,6 +42,8 @@
  * Definitions related to sockets: types, address families, options.
  */
 
+extern int in_def_drop;
+
 /*
  * Data types.
  */
diff -r 1e55e1aa8b7f sys/sys/socketvar.h
--- a/sys/sys/socketvar.h	Sun May 04 01:33:02 2014 +0000
+++ b/sys/sys/socketvar.h	Fri Jul 11 13:32:06 2014 +1000
@@ -342,11 +342,16 @@
 	    struct thread *td);
 int	sopoll_generic(struct socket *so, int events,
 	    struct ucred *active_cred, struct thread *td);
+int	sopoll_mpstream(struct socket *so, int events,
+	    struct ucred *active_cred, struct thread *td);
 int	soreceive(struct socket *so, struct sockaddr **paddr, struct uio *uio,
 	    struct mbuf **mp0, struct mbuf **controlp, int *flagsp);
 int	soreceive_stream(struct socket *so, struct sockaddr **paddr,
 	    struct uio *uio, struct mbuf **mp0, struct mbuf **controlp,
 	    int *flagsp);
+int	soreceive_mpstream(struct socket *so, struct sockaddr **paddr,
+	    struct uio *uio, struct mbuf **mp0, struct mbuf **controlp,
+	    int *flagsp);
 int	soreceive_dgram(struct socket *so, struct sockaddr **paddr,
 	    struct uio *uio, struct mbuf **mp0, struct mbuf **controlp,
 	    int *flagsp);
